"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations

from typing import Literal

from pydantic import model_serializer
from typing_extensions import NotRequired, TypedDict

from friendli.types import UNSET, UNSET_SENTINEL, BaseModel, Nullable, OptionalNullable

URLImageItemResponseFormat = Literal["url", "raw", "png", "jpeg", "jpg"]
r"""The format of the generated iamge. One of `url(default)`, `raw`, `png`, `jpeg`, and `jpg`."""


class URLImageItemTypedDict(TypedDict):
    response_format: URLImageItemResponseFormat
    r"""The format of the generated iamge. One of `url(default)`, `raw`, `png`, `jpeg`, and `jpg`."""
    url: str
    r"""The URL of the generated image."""
    seed: NotRequired[Nullable[int]]
    r"""The seed used during image generation."""


class URLImageItem(BaseModel):
    response_format: URLImageItemResponseFormat
    r"""The format of the generated iamge. One of `url(default)`, `raw`, `png`, `jpeg`, and `jpg`."""

    url: str
    r"""The URL of the generated image."""

    seed: OptionalNullable[int] = UNSET
    r"""The seed used during image generation."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["seed"]
        nullable_fields = ["seed"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
